var ret = {
    blob: null,
    nativePath: null,
};

exports.audio = function () {
    var maxDuration = 1800;
    var record;
    var timer;
    var duration;
    var duration2;
    var countImage;
    var isRecording = false;
    var audioPlayer = Ti.Media.createAudioPlayer({
        allowBackground: false,
        url: "",
    });

    var v = Ti.UI.createView({
        top: 0,
        width: osname == "iphone" ? Ti.UI.FILL : Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        borderWidth: 0,
        zIndex: -999,
        backgroundColor: "#fff",
        layout: "vertical",
    });

    var viewButton = Ti.UI.createView({
        top: 20,
        width: 150,
        height: 150,
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        borderWidth: 0,
        zIndex: -999,
    });

    var trash = Ti.UI.createImageView({
        image: "/assets/images/Record_Button_TrashCan.png",
        width: 150,
        height: 150,
        top: 20,
    });

    var recordStartStop = Ti.UI.createView({
        width: 150,
        height: 150,
        backgroundImage: "/assets/images/Record_Button_1.png",
        top: 20,
    });

    var buttonLabel = Ti.UI.createLabel({
        color: "#000",
        text: "Record",
        textAlign: "center",
        color: "white",
        width: Ti.UI.SIZE,
    });

    var viewButtonsPlayback = Ti.UI.createView({
        top: 40,
        width: "45%",
        height: Ti.UI.SIZE,
    });

    var recordPlay = Ti.UI.createView({
        backgroundColor: "#fff",
        left: 10,
        height: 50,
        width: 50,
        backgroundImage: "/assets/images/Play.png",
    });

    var recordStop = Ti.UI.createView({
        backgroundColor: "#fff",
        right: 10,
        width: 50,
        height: 50,
        backgroundImage: "/assets/images/Stop.png",
    });

    var timeLabel = Ti.UI.createLabel({
        top: 20,
        text: "",
        textAlign: "center",
        color: "black",
        width: Ti.UI.SIZE,
    });

    var deleteAlert = Ti.UI.createAlertDialog({
        cancel: 1,
        buttonNames: ["OK", L("FORMabanOptBtCancel")],
        title: L("APPName"),
        message: "Tem certeza que deseja apagar a gravação?",
    });

    // BEGIN Progress Bar
    var opts = {};
    opts.percent = 0;
    opts.size = 130;
    opts.margin = 4;
    opts.backgroundColor = "#fff";
    opts.progressColor = "blue";
    opts.topper = {
        color: "#fff",
        size: 36,
    };
    var mainHolderProgressBar = Ti.UI.createView({
        top: 28,
        width: opts.size + opts.margin,
        height: opts.size + opts.margin,
        borderRadius: (opts.size + opts.margin) / 2,
        backgroundColor: opts.backgroundColor,
        zIndex: -999,
    });
    var holder = Ti.UI.createView({
        width: opts.size,
        height: opts.size,
        borderRadius: opts.size / 2,
    });
    var layer1 = Ti.UI.createView({
        width: opts.size,
        height: opts.size,
        borderRadius: opts.size / 2,
        backgroundColor: opts.progressColor,
    });
    var layer2 = Ti.UI.createView({
        left: 0,
        width: opts.size / 2,
        height: opts.size,
        anchorPoint: {
            x: 1,
            y: 0.5,
        },
        backgroundColor: opts.backgroundColor,
    });
    var layer3 = Ti.UI.createView({
        right: 0,
        width: opts.size / 2,
        height: opts.size,
        anchorPoint: {
            x: 0,
            y: 0.5,
        },
        backgroundColor: opts.backgroundColor,
    });
    var layer4 = Ti.UI.createView({
        right: 0,
        width: opts.size / 2,
        height: opts.size,
        anchorPoint: {
            x: 0,
            y: 0.5,
        },
        backgroundColor: opts.progressColor,
    });
    var topper = Ti.UI.createView({
        width: opts.topper.size,
        height: opts.topper.size,
        borderRadius: opts.topper.size / 2,
        backgroundColor: opts.topper.color,
    });

    mainHolderProgressBar.add(holder);
    holder.add(layer1);
    holder.add(layer2);
    holder.add(layer3);
    holder.add(layer4);
    holder.add(topper);

    var percent = opts.percent;
    var angle = 360 * percent;
    layer2.visible = angle > 180 ? false : true;
    layer4.visible = angle > 180 ? true : false;
    layer3.transform = Ti.UI.create2DMatrix().rotate(angle);
    // END Progress Bar

    if (osname != "android") {
        console.log("######## creating audio recorder");
        var audioRecorder = Ti.Media.createAudioRecorder();
        console.log("######## audio recorder created = " + audioRecorder);
        Ti.Media.audioSessionCategory =
            Ti.Media.AUDIO_SESSION_CATEGORY_PLAY_AND_RECORD;
    } else {
        console.log("######## creating audio recorder on ANDROID!");
        var audioRecorder = Ti.Media.createAudioRecorder();
    }

    var audioPathLbl = Ti.UI.createLabel({
        top: 40,
        width: "80%",
        text: "nativePath: \n" + String(ret.nativePath),
        // width: Ti.UI.FILL,
        color: "#000",
        font: { fontSize: 16, fontWeight: "bold" },
    });

    function updatePathLabel(str) {
        return "nativePath:  " + String(str);
    }

    var persistentAudio = Ti.App.Properties.getString("audio", null);
    if (persistentAudio) {
        var persfile = Ti.Filesystem.getFile(persistentAudio);
        console.log("persfile = " + persfile);
        if (persfile.exists()) {
            var blob = persfile.read();
            console.log("blob = ");
            console.log(JSON.stringify(blob, 4, null));
            // exports.handleImage(blob);
            audioPlayer.url = blob;
            audioPathLbl.text = updatePathLabel(persistentAudio);
        }
    }

    recordStartStop.add(buttonLabel);
    viewButton.add(mainHolderProgressBar);
    viewButton.add(recordStartStop);
    viewButtonsPlayback.add(recordPlay);
    viewButtonsPlayback.add(recordStop);
    v.add(viewButton);
    v.add(timeLabel);
    v.add(viewButtonsPlayback);
    v.add(audioPathLbl);
    viewButtonsPlayback.hide();

    var persistentAudio = Ti.App.Properties.getString("audio", null);
    console.log("persistentAudio = " + persistentAudio);

    // if it was saved
    if (persistentAudio) {
        ret.nativePath = persistentAudio;
        console.log("--------Audio = " + ret.nativePath);
        var f = Ti.Filesystem.getFile(ret.nativePath);
        if (f.exists()) {
            console.log("--------Exists = " + f.getNativePath());
            // audioPlayer.url = f.getNativePath();
            audioPlayer.url = ret.nativePath;
        } else {
            console.log("-------- Do not Exist = " + ret.nativePath);
            audioPlayer.url = ret.nativePath;
        }
        timeLabel.text = "00:00:00";
        recordStartStop.backgroundImage = "/assets/images/Record_Button_1.png";
        viewButton.remove(recordStartStop);
        viewButton.add(trash);
        viewButtonsPlayback.show();
        recordPlay.touchEnabled = true;
        recordStop.touchEnabled = false;
        recordPlay.backgroundImage = "/assets/images/Play_Enabled.png";
        recordStop.backgroundImage = "/assets/images/Stop.png";
        isRecording = false;
    }

    function stopAudio() {
        recordStartStop.backgroundImage = "/assets/images/Record_Button_1.png";
        timeLabel.text = "00:00:00";
        recordPlay.touchEnabled = true;
        recordStop.touchEnabled = false;
        recordPlay.backgroundImage = "/assets/images/Play_Enabled.png";
        recordStop.backgroundImage = "/assets/images/Stop.png";
    }

    function changeTime() {
        console.log("duration = " + duration);
        console.log("Maxduration = " + maxDuration);
        if (duration < maxDuration) {
            console.log("noMax");
            duration++;
            showTimer(duration * 1000);
            timeLabel.text = showTimer(duration * 1000);
        } else {
            stopRecording();
            alert("Você atingiu o tempo máximo de gravação!");
            console.log("######## File = " + record.getNativePath());
        }
    }

    function recDuration() {
        console.log("Duration2 = " + duration2);
        console.log("Maxduration = " + maxDuration);
        if (duration2 < maxDuration) {
            duration2++;
            updateProgressBar(duration2 / maxDuration);
            console.log("Percent - " + duration2 / maxDuration);
        } else {
            stopRecording();
            alert("Você atingiu o tempo máximo de gravação!");
            console.log("######## File = " + record.getNativePath());
        }
    }

    function recAnimate() {
        if (countImage >= 1 && countImage <= 3) {
            console.log("/assets/images/Record_Button_" + countImage + ".png");
            recordStartStop.backgroundImage =
                "/assets/images/Record_Button_" + countImage + ".png";
            countImage++;
        } else {
            countImage = 1;
        }
    }

    function showTimer(duration) {
        var s = duration;
        var ms = s % 1000;
        s = (s - ms) / 1000;
        var secs = s % 60;
        s = (s - secs) / 60;
        var mins = s % 60;
        var hrs = (s - mins) / 60;

        if (hrs < 10) {
            hrs = "0" + hrs;
        }
        if (mins < 10) {
            mins = "0" + mins;
        }
        if (secs < 10) {
            secs = "0" + secs;
        }

        return hrs + ":" + mins + ":" + secs;
    }

    function startRecording() {
        buttonLabel.text = L("FORMAudioStop");
        duration = 0;
        duration2 = 0;
        timer = setInterval(changeTime, 1000);
        if (osname != "android") {
            timerImage = setInterval(recDuration, 1000);
        } else {
            timerImage = setInterval(recAnimate, 333);
        }
        timeLabel.show();
        viewButtonsPlayback.hide();
        if (osname != "android") {
            audioRecorder.setCompression(Ti.Media.AUDIO_FORMAT_AAC);
            audioRecorder.setFormat(Titanium.Media.AUDIO_FILEFORMAT_MP4A);
        }
        audioRecorder.start();
        isRecording = true;
    }

    function stopRecording() {
        if (osname != "android") {
            updateProgressBar(0);
        }
        clearInterval(timer);
        countImage = 1;
        clearInterval(timerImage);
        recordStartStop.backgroundImage = "/assets/images/Record_Button_1.png";
        viewButton.remove(recordStartStop);
        viewButton.add(trash);
        viewButtonsPlayback.show();
        recordPlay.touchEnabled = true;
        recordStop.touchEnabled = false;
        recordPlay.backgroundImage = "/assets/images/Play_Enabled.png";
        recordStop.backgroundImage = "/assets/images/Stop.png";

        record = audioRecorder.stop();

        var blob = record.read();
        var onlyName = blob.getNativePath() + "";
        var fileName = "audio1.wav";
        var faudio = Ti.Filesystem.getFile(externalStorageDirectory, fileName);
        faudio.write(blob);
        if (faudio.exists()) {
            console.log("######## New File Path = " + faudio.getNativePath());
            ret.nativePath = faudio.getNativePath();
            Ti.App.Properties.setString("audio", faudio.getNativePath());
            updatePathLabel(faudio.getNativePath());
        } else {
            console.log("######## Error");
        }

        isRecording = false;
    }

    function updateProgressBar(percent) {
        angle = 360 * percent;
        layer2.visible = angle > 180 ? false : true;
        layer4.visible = angle > 180 ? true : false;
        layer3.transform = Ti.UI.create2DMatrix().rotate(angle);
    }

    // Event Listeners

    deleteAlert.addEventListener("click", function (e) {
        if (e.index == 0) {
            audioPlayer.stop();
            if (osname == "android") {
                audioPlayer.release();
            }
            Ti.Filesystem.getFile(ret.nativePath).deleteFile();
            ret.nativePath = null;
            viewButton.remove(trash);
            viewButton.add(recordStartStop);
            viewButtonsPlayback.hide();
            timeLabel.hide();
            buttonLabel.text = L("FORMAudioRecord");
            isRecording = false;
        } else {
            return;
        }
    });

    recordStartStop.addEventListener("click", function (e) {
        console.log("######## Click 1");
        if (osname != "android") {
            Ti.Media.audioSessionCategory =
                Ti.Media.AUDIO_SESSION_CATEGORY_PLAY_AND_RECORD;
        }
        if (!isRecording) {
            if (!Ti.Media.hasAudioRecorderPermissions()) {
                Ti.Media.requestAudioRecorderPermissions(function (e) {
                    console.log("######## e = " + JSON.stringify(e, 4, null));
                    if (e.success) {
                        console.log("######## Click 2");
                        startRecording();
                    } else {
                        console.log("######## Click 3");
                        alert(L("FORMAudioPermission"));
                    }
                });
            } else {
                console.log("######## Click 4");
                startRecording();
            }
        } else {
            console.log("######## Click 5");
            stopRecording();
        }
    });

    recordPlay.addEventListener("click", function (e) {
        console.log("######## creating audio player");
        console.log("######## File = " + ret.nativePath);
        if (osname != "android") {
            Ti.Media.audioSessionCategory =
                Ti.Media.AUDIO_SESSION_CATEGORY_PLAYBACK;
        }
        timeLabel.show();
        recordPlay.touchEnabled = false;
        recordStop.touchEnabled = true;
        recordPlay.backgroundImage = "/assets/images/Play.png";
        recordStop.backgroundImage = "/assets/images/Stop_Enabled.png";
        if (ret.nativePath) {
            // var f = Ti.Filesystem.getFile(ret.nativePath);
            var f = Ti.Filesystem.getFile(ret.nativePath);
            if (f.exists()) {
                console.log("######## File Exists");
                audioPlayer.url = ret.nativePath;
            } else {
                audioPlayer.url = ret.nativePath;
            }
        }
        audioPlayer.start();
    });

    recordStop.addEventListener("click", function (e) {
        stopAudio();
        audioPlayer.stop();
        if (osname == "android") {
            audioPlayer.release();
        }
    });

    trash.addEventListener("click", function (e) {
        deleteAlert.show();
    });

    audioPlayer.addEventListener("progress", function (e) {
        console.log("eProgress = " + e.progress);
        console.log("isplaying = " + audioPlayer.playing);
        timeLabel.text = showTimer(e.progress);
    });

    audioPlayer.addEventListener("complete", function (e) {
        console.log("----Completed PLAY");
        stopAudio();
    });

    Ti.App.addEventListener("stopAudio", function () {
        console.log("----Stoped play");
        audioPlayer.stop();
    });

    return v;
};
