var ret = {
    blob: null,
    nativePath: null,
    thumb: {
        height: null,
        width: null,
        thumblob: null,
    },
};

exports.requestPerms = function () {
    console.log("exports.requestPerms()");
    if (osname == "iphone") {
        var map = {};
        map[Ti.Media.CAMERA_AUTHORIZATION_AUTHORIZED] =
            "CAMERA_AUTHORIZATION_AUTHORIZED";
        map[Ti.Media.CAMERA_AUTHORIZATION_DENIED] =
            "CAMERA_AUTHORIZATION_DENIED";
        map[Ti.Media.CAMERA_AUTHORIZATION_RESTRICTED] =
            "CAMERA_AUTHORIZATION_RESTRICTED";
        map[Ti.Media.CAMERA_AUTHORIZATION_NOT_DETERMINED] =
            "CAMERA_AUTHORIZATION_NOT_DETERMINED";
        var cameraAuthorization = Ti.Media.cameraAuthorization;
        if (cameraAuthorization === Ti.Media.CAMERA_AUTHORIZATION_RESTRICTED) {
            return;
        } else if (
            cameraAuthorization === Ti.Media.CAMERA_AUTHORIZATION_DENIED
        ) {
            return;
        }
        var settingsURL = Ti.App.iOS.applicationOpenSettingsURL;
        console.log(
            "debug 1 ============================================================================="
        );
        Ti.Media.requestCameraPermissions(function (e) {
            console.log(
                "debug 2 ================================================"
            );
            if (!e.success) {
                console.error("CAMERA ACCESS DENIED BY USER");
                var dialog = Ti.UI.createAlertDialog({
                    cancel: 1,
                    buttonNames: ["opt1", "opt2"],
                    message: "grant permissions please",
                    title: "Camera Permissions",
                });

                dialog.addEventListener("click", function (e) {
                    if (e.index === 0) {
                        if (Ti.Platform.canOpenURL(settingsURL)) {
                            Ti.Platform.openURL(settingsURL);
                        }
                    }
                });
                dialog.show();
            }
        });
    } else {
        var dialog = Ti.UI.createAlertDialog({
            cancel: 1,
            buttonNames: ["opt1", "opt2"],
            message: "grant permissions please",
            title: "camera permissions",
        });

        dialog.addEventListener("click", function (e) {
            if (e.index === 0) {
                var intent = Ti.Android.createIntent({
                    action: "android.settings.APPLICATION_SETTINGS",
                });
                intent.addFlags(Ti.Android.FLAG_ACTIVITY_NEW_TASK);
                Ti.Android.currentActivity.startActivity(intent);
            }
        });
        dialog.show();
    }
};

exports.handleImage = function (e) {
    // Pre defined WIDTH sizes to force Portrait resize acording to Admin's especification
    var widthVeryLow = 320; //Resolution = 136 kilo pixels
    var widthLow = 640; //Resolution = 307 kilo pixels
    var widthMid = 1280; //Resolution = 2.18 mega pixels
    var widthHigh = 2590; //Resolution = 8.71 mega pixels
    var widthVeryHigh = 5120; //Resolution = 34.9 mega pixels
    // Pre defined HEIGHT sizes to force Landscape resize acording to Admin's especification
    var heightVeryLow = 240; //Resolution = 136 kilo pixels
    var heightLow = 480; //Resolution = 307 kilo pixels
    var heightMid = 960; //Resolution = 2.18 mega pixels
    var heightHigh = 1920; //Resolution = 8.71 mega pixels
    var heightVeryHigh = 3840; //Resolution = 34.9 mega pixels

    var landscape = e.media.width > e.media.height ? true : false;
    var squared = e.media.width == e.media.height ? true : false;

    if (e.media.width < 200 || e.media.height < 200) {
        console.log("minimium 200x200");
        return;
    }

    if (landscape) {
        var ratio = e.media.width / e.media.height;
    } else {
        var ratio = e.media.height / e.media.width;
    }

    var blob = e.media;

    if (landscape) {
        var thumb = blob.imageAsResized(180, 180);
        ret.thumb.height = thumb.height;
        ret.thumb.width = thumb.width;
    } else {
        console.log("portrait");
        var thumb = blob.imageAsResized(240, 240);
        ret.thumb.height = thumb.height;
        ret.thumb.width = thumb.width;
    }
    if (squared) {
        ret.thumb.height = 240;
        ret.thumb.width = 240;
        var thumb = blob.imageAsResized(480, 480);
    }

    ret.thumb.thumblob = thumb;

    //Store the file names (of the local storage path)
    if (osname == "android") {
        var fpic = Ti.Filesystem.getFile(
            externalStorageDirectory,
            // applicationDataDirectory,
            "photo1.jpg"
        );
        fpic.write(blob);
        console.log(fpic.nativePath);
        if (fpic.nativePath) {
            Ti.App.Properties.setString("photo", fpic.nativePath);
            ret.nativePath = fpic.nativePath;
        } else {
            ret.nativePath = null;
        }
    } else {
        if (blob) {
            ret.nativePath = "photo1.jpg";
            var fpic = Ti.Filesystem.getFile(
                applicationDataDirectory,
                ret.nativePath
            );
            fpic.write(blob);
            Ti.App.Properties.setString("photo", fpic.nativePath);
        } else {
            ret.nativePath = null;
        }
    }

    Ti.App.fireEvent("loadPhoto");

    return ret;
};

exports.photo = function () {
    photoView = Ti.UI.createView({
        backgroundColor: "transparent",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        top: 20,
        bottom: 20,
        layout: "vertical",
        bubbleParent: false,
    });

    var placeholder = Ti.UI.createImageView({
        image: "/assets/images/camera-wide.png",
        // width: 240,
        // width: Ti.UI.FILL,
        height: 180,
        autorotate: true,
    });

    var imagePathLbl = Ti.UI.createLabel({
        top: 40,
        width: "80%",
        text: "nativePath: \n" + String(ret.nativePath),
        // width: Ti.UI.FILL,
        color: "#000",
        font: { fontSize: 16, fontWeight: "bold" },
    });

    var imageToBlob = Ti.UI.createImageView();

    var permissions = [
        "android.permission.CAMERA",
        "android.permission.WRITE_EXTERNAL_STORAGE",
    ];

    var gallery = true;

    // Ti.Media.requestCameraPermissions(function (e) {
    //     console.log("Camera permissions granted!");
    // });

    var takePhoto = Ti.UI.createButton({
        title: "take photo",
        backgroundColor: "gray",
        backgroundSelectedColor: "silver",
        color: "#000",
        font: {
            fontSize: 14,
            fontFamily: "ProximaNova-Regular",
        },
        top: 20,
        borderRadius: 6,
        width: 240,
        height: 40,
        bubbleParent: false,
    });

    takePhoto.addEventListener("click", function () {
        // GALLERY ALLOWED
        if (gallery) {
            var opt = Ti.UI.createOptionDialog({
                cancel: 2,
                title: "Take photo",
                options: ["take photo", "choose from gallery", "cancel"],
            });

            opt.addEventListener("click", function (e) {
                switch (e.index) {
                    case 0:
                        if (!Ti.Media.hasCameraPermissions()) {
                            if (osname == "iphone") {
                                Ti.Media.requestCameraPermissions(function (e) {
                                    if (!e.success) {
                                        logme("User denied camera permission.");
                                        exports.requestPerms();
                                    } else {
                                        Ti.Media.showCamera({
                                            allowEditing: false,
                                            mediaTypes: [
                                                Ti.Media.MEDIA_TYPE_PHOTO,
                                            ],
                                            saveToPhotoGallery: true,
                                            error: function (e) {
                                                alert(
                                                    "Error on Photo Capture 1: " +
                                                        e.code +
                                                        ": " +
                                                        e.error
                                                );
                                            },
                                            success: function (e) {
                                                ret = exports.handleImage(e);
                                                console.log(
                                                    JSON.stringify(ret, null, 4)
                                                );
                                                placeholder.image =
                                                    ret.thumb.thumblob;
                                                placeholder.height =
                                                    ret.thumb.height;
                                                placeholder.width =
                                                    ret.thumb.width;
                                            },
                                        });
                                    }
                                });
                            } else {
                                Ti.Android.requestPermissions(
                                    permissions,
                                    function (e) {
                                        if (!e.success) {
                                            logme(
                                                "User denied camera permission."
                                            );
                                            exports.requestPerms();
                                        } else {
                                            Ti.Media.showCamera({
                                                allowEditing: false,
                                                mediaTypes: [
                                                    Ti.Media.MEDIA_TYPE_PHOTO,
                                                ],
                                                saveToPhotoGallery:
                                                    osname == "android" &&
                                                    ver >= 10
                                                        ? false
                                                        : true, //workaround for bug on showCamera on Android10
                                                error: function (e) {
                                                    alert(
                                                        "Error on Photo Capture2: " +
                                                            e.code +
                                                            ": " +
                                                            e.error
                                                    );
                                                },
                                                success: function (e) {
                                                    ret = exports.handleImage(
                                                        e
                                                    );
                                                    console.log(
                                                        JSON.stringify(
                                                            ret,
                                                            4,
                                                            null
                                                        )
                                                    );
                                                    placeholder.image =
                                                        ret.thumb.thumblob;
                                                    placeholder.height =
                                                        ret.thumb.height;
                                                    placeholder.width =
                                                        ret.thumb.width;
                                                },
                                            });
                                        }
                                    }
                                );
                            }
                        } else {
                            Ti.Media.showCamera({
                                allowEditing: false,
                                mediaTypes: [Ti.Media.MEDIA_TYPE_PHOTO],
                                saveToPhotoGallery:
                                    osname == "android" && ver >= 10
                                        ? false
                                        : true, //workaround for bug on showCamera on Android10
                                error: function (e) {
                                    alert(
                                        "Error on Photo Capture3: " +
                                            e.code +
                                            ": " +
                                            e.error
                                    );
                                },
                                success: function (e) {
                                    ret = exports.handleImage(e);
                                    console.log(JSON.stringify(ret, null, 4));
                                    placeholder.image = ret.thumb.thumblob;
                                    placeholder.height = ret.thumb.height;
                                    placeholder.width = ret.thumb.width;
                                },
                            });
                        }

                        break;

                    case 1:
                        if (!Ti.Media.hasCameraPermissions()) {
                            if (osname == "iphone") {
                                Ti.Media.requestCameraPermissions(function (e) {
                                    if (!e.success) {
                                        logme("User denied camera permission.");
                                        exports.requestPerms()();
                                    } else {
                                        Ti.Media.openPhotoGallery({
                                            allowEditing: false,
                                            mediaTypes: [
                                                Ti.Media.MEDIA_TYPE_PHOTO,
                                            ],
                                            error: function (e) {
                                                alert(
                                                    "Error on Photo Capture4: " +
                                                        e.code +
                                                        ": " +
                                                        e.error
                                                );
                                            },
                                            success: function (e) {
                                                ret = exports.handleImage(e);
                                                console.log(
                                                    JSON.stringify(ret, null, 4)
                                                );
                                                placeholder.image =
                                                    ret.thumb.thumblob;
                                                placeholder.height =
                                                    ret.thumb.height;
                                                placeholder.width =
                                                    ret.thumb.width;
                                            },
                                        });
                                    }
                                });
                            } else {
                                Ti.Android.requestPermissions(
                                    permissions,
                                    function (e) {
                                        if (!e.success) {
                                            logme(
                                                "User denied camera permission."
                                            );
                                            exports.requestPerms();
                                        } else {
                                            Ti.Media.openPhotoGallery({
                                                allowEditing: false,
                                                mediaTypes: [
                                                    Ti.Media.MEDIA_TYPE_PHOTO,
                                                ],
                                                error: function (e) {
                                                    alert(
                                                        "Error on Photo Capture5: " +
                                                            e.code +
                                                            ": " +
                                                            e.error
                                                    );
                                                },
                                                success: function (e) {
                                                    ret = exports.handleImage(
                                                        e
                                                    );
                                                    console.log(
                                                        JSON.stringify(
                                                            ret,
                                                            4,
                                                            null
                                                        )
                                                    );
                                                    placeholder.image =
                                                        ret.thumb.thumblob;
                                                    placeholder.height =
                                                        ret.thumb.height;
                                                    placeholder.width =
                                                        ret.thumb.width;
                                                },
                                            });
                                        }
                                    }
                                );
                            }
                        } else {
                            Ti.Media.openPhotoGallery({
                                allowEditing: false,
                                mediaTypes: [Ti.Media.MEDIA_TYPE_PHOTO],
                                error: function (e) {
                                    alert(
                                        "Error on Photo Capture6: " +
                                            e.code +
                                            ": " +
                                            e.error
                                    );
                                },
                                success: function (e) {
                                    ret = exports.handleImage(e);
                                    console.log(JSON.stringify(ret, null, 4));
                                    placeholder.image = ret.thumb.thumblob;
                                    placeholder.height = ret.thumb.height;
                                    placeholder.width = ret.thumb.width;
                                },
                            });
                        }
                        break;
                }
            });

            opt.show();
        } else {
            if (!Ti.Media.hasCameraPermissions()) {
                if (osname == "iphone") {
                    Ti.Media.requestCameraPermissions(function (e) {
                        if (!e.success) {
                            logme("User denied camera permission.");
                            exports.requestPerms()();
                        } else {
                            Ti.Media.showCamera({
                                allowEditing: false,
                                mediaTypes: [Ti.Media.MEDIA_TYPE_PHOTO],
                                saveToPhotoGallery: true,
                                error: function (e) {
                                    alert(
                                        "Error on Photo Capture7: " +
                                            e.code +
                                            ": " +
                                            e.error
                                    );
                                },
                                success: function (e) {
                                    ret = exports.handleImage(e);
                                    console.log(JSON.stringify(ret, null, 4));
                                    placeholder.image = ret.thumb.thumblob;
                                    placeholder.height = ret.thumb.height;
                                    placeholder.width = ret.thumb.width;
                                },
                            });
                        }
                    });
                } else {
                    Ti.Android.requestPermissions(permissions, function (e) {
                        if (!e.success) {
                            logme("User denied camera permission.");
                            exports.requestPerms()();
                        } else {
                            Ti.Media.showCamera({
                                allowEditing: false,
                                mediaTypes: [Ti.Media.MEDIA_TYPE_PHOTO],
                                saveToPhotoGallery:
                                    osname == "android" && ver >= 10
                                        ? false
                                        : true, //workaround for bug on showCamera on Android10,
                                error: function (e) {
                                    alert(
                                        "Error on Photo Capture8: " +
                                            e.code +
                                            ": " +
                                            e.error
                                    );
                                },
                                success: function (e) {
                                    ret = exports.handleImage(e);
                                    console.log(JSON.stringify(ret, null, 4));
                                    placeholder.image = ret.thumb.thumblob;
                                    placeholder.height = ret.thumb.height;
                                    placeholder.width = ret.thumb.width;
                                },
                            });
                        }
                    });
                }
            } else {
                Ti.Media.showCamera({
                    allowEditing: false,
                    mediaTypes: [Ti.Media.MEDIA_TYPE_PHOTO],
                    saveToPhotoGallery:
                        osname == "android" && ver >= 10 ? false : true, //workaround for bug on showCamera on Android10,
                    error: function (e) {
                        alert(
                            "Error on Photo Capture9: " +
                                e.code +
                                ": " +
                                e.error
                        );
                    },
                    success: function (e) {
                        ret = exports.handleImage(e);
                        console.log(JSON.stringify(ret, null, 4));
                        placeholder.image = ret.thumb.thumblob;
                        placeholder.height = ret.thumb.height;
                        placeholder.width = ret.thumb.width;
                    },
                });
            }
        }
    });

    function updatePathLabel(str) {
        return "nativePath:  " + String(str);
    }

    var persistentPhoto = Ti.App.Properties.getString("photo", null);
    if (persistentPhoto) {
        var persfile = Ti.Filesystem.getFile(persistentPhoto);
        console.log("persfile = " + persfile);
        if (persfile.exists()) {
            var blob = persfile.read();
            console.log("blob = ");
            console.log(JSON.stringify(blob, 4, null));
            // exports.handleImage(blob);
            // placeholder.image = persistentPhoto.thumb.thumblob;
            placeholder.image = blob;
            imagePathLbl.text = updatePathLabel(persistentPhoto);
        }
    }

    photoView.add(placeholder);
    photoView.add(takePhoto);
    photoView.add(imagePathLbl);

    photoView.photoObj = ret;

    var loadPhoto = function () {
        imagePathLbl.text = ret.nativePath;
    };

    Ti.App.addEventListener("loadPhoto", loadPhoto);

    return photoView;
};
